/*
 * Copyright (c) 2012 Red Hat, Inc. <http://www.redhat.com>
 * This file is part of GlusterFS.
 *
 * This file is licensed to you under your choice of the GNU Lesser
 * General Public License, version 3 or any later version (LGPLv3 or
 * later), or the GNU General Public License, version 2 (GPLv2), in all
 * cases as published by the Free Software Foundation.
 */

/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _ACL_H_RPCGEN
#define _ACL_H_RPCGEN

#include <rpc/rpc.h>
#include "xdr-nfs3.h"

#ifdef __cplusplus
extern "C" {
#endif


struct aclentry {
	int type;
	int uid;
	int perm;
};
typedef struct aclentry aclentry;

struct getaclargs {
	netobj fh;
	int mask;
};
typedef struct getaclargs getaclargs;

struct getaclreply {
	int status;
	int attr_follows;
	struct fattr3 attr;
	int mask;
	int aclcount;
	struct {
		u_int aclentry_len;
		struct aclentry *aclentry_val;
	} aclentry;
	int daclcount;
	struct {
		u_int daclentry_len;
		struct aclentry *daclentry_val;
	} daclentry;
};
typedef struct getaclreply getaclreply;

struct setaclargs {
	netobj fh;
	int mask;
	int aclcount;
	struct {
		u_int aclentry_len;
		struct aclentry *aclentry_val;
	} aclentry;
	int daclcount;
	struct {
		u_int daclentry_len;
		struct aclentry *daclentry_val;
	} daclentry;
};
typedef struct setaclargs setaclargs;

struct setaclreply {
	int status;
	int attr_follows;
	struct fattr3 attr;
};
typedef struct setaclreply setaclreply;

#define ACL3_NULL 0
#define ACL3_GETACL 1
#define ACL3_SETACL 2
#define ACL3_PROC_COUNT 3
/* the xdr functions */

#if defined(__STDC__) || defined(__cplusplus)
extern  bool_t xdr_aclentry (XDR *, aclentry*);
extern  bool_t xdr_getaclargs (XDR *, getaclargs*);
extern  bool_t xdr_getaclreply (XDR *, getaclreply*);
extern  bool_t xdr_setaclargs (XDR *, setaclargs*);
extern  bool_t xdr_setaclreply (XDR *, setaclreply*);

#else /* K&R C */
extern bool_t xdr_aclentry ();
extern bool_t xdr_getaclargs ();
extern bool_t xdr_getaclreply ();
extern bool_t xdr_setaclargs ();
extern bool_t xdr_setaclreply ();

#endif /* K&R C */

#ifdef __cplusplus
}
#endif

#endif /* !_ACL_H_RPCGEN */
